import { Map, OrderedSet } from "immutable";
export declare class TypeAttributeKind<T> {
    readonly name: string;
    readonly combine: (a: T, b: T) => T;
    readonly makeInferred: (a: T) => T;
    readonly stringify: (a: T) => string | undefined;
    constructor(name: string, combine: ((a: T, b: T) => T) | undefined, makeInferred: ((a: T) => T) | undefined, stringify: ((a: T) => string | undefined) | undefined);
    makeAttributes(value: T): TypeAttributes;
    tryGetInAttributes(a: TypeAttributes): T | undefined;
    setInAttributes(a: TypeAttributes, value: T): TypeAttributes;
    modifyInAttributes(a: TypeAttributes, modify: (value: T | undefined) => T | undefined): TypeAttributes;
    setDefaultInAttributes(a: TypeAttributes, makeDefault: () => T): TypeAttributes;
    equals(other: any): boolean;
    hashCode(): number;
}
export declare type TypeAttributes = Map<TypeAttributeKind<any>, any>;
export declare const emptyTypeAttributes: TypeAttributes;
export declare function combineTypeAttributes(attributeArray: TypeAttributes[]): TypeAttributes;
export declare function combineTypeAttributes(a: TypeAttributes, b: TypeAttributes): TypeAttributes;
export declare function makeTypeAttributesInferred(attr: TypeAttributes): TypeAttributes;
export declare const descriptionTypeAttributeKind: TypeAttributeKind<OrderedSet<string>>;
export declare const propertyDescriptionsTypeAttributeKind: TypeAttributeKind<Map<string, OrderedSet<string>>>;
