import { Set } from "immutable";
import { Type } from "./Type";
import { TypeRef, UnionBuilder, TypeBuilder, TypeLookerUp, GraphRewriteBuilder } from "./TypeBuilder";
import { TypeAttributes } from "./TypeAttributes";
export declare class UnifyUnionBuilder extends UnionBuilder<TypeBuilder & TypeLookerUp, TypeRef[], TypeRef[], TypeRef[]> {
    private readonly _makeEnums;
    private readonly _makeClassesFixed;
    private readonly _unifyTypes;
    constructor(typeBuilder: TypeBuilder & TypeLookerUp, _makeEnums: boolean, _makeClassesFixed: boolean, _unifyTypes: (typesToUnify: TypeRef[], typeAttributes: TypeAttributes) => TypeRef);
    protected makeEnum(enumCases: string[], counts: {
        [name: string]: number;
    }, typeAttributes: TypeAttributes, forwardingRef: TypeRef | undefined): TypeRef;
    protected makeClass(classes: TypeRef[], maps: TypeRef[], typeAttributes: TypeAttributes, forwardingRef: TypeRef | undefined): TypeRef;
    protected makeArray(arrays: TypeRef[], typeAttributes: TypeAttributes, forwardingRef: TypeRef | undefined): TypeRef;
}
export declare function unionBuilderForUnification<T extends Type>(typeBuilder: GraphRewriteBuilder<T>, makeEnums: boolean, makeClassesFixed: boolean, conflateNumbers: boolean): UnionBuilder<TypeBuilder & TypeLookerUp, TypeRef[], TypeRef[], TypeRef[]>;
export declare function unifyTypes<T extends Type>(types: Set<Type>, typeAttributes: TypeAttributes, typeBuilder: GraphRewriteBuilder<T>, unionBuilder: UnionBuilder<TypeBuilder & TypeLookerUp, TypeRef[], TypeRef[], TypeRef[]>, conflateNumbers: boolean, maybeForwardingRef?: TypeRef): TypeRef;
