"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_stream_1 = require("./get-stream");
var _ = require("lodash");
var immutable_1 = require("immutable");
var URI = require("urijs");
var targetLanguages = require("./Language/All");
var Support_1 = require("./Support");
var CompressedJSON_1 = require("./CompressedJSON");
var CombineClasses_1 = require("./CombineClasses");
var JSONSchemaInput_1 = require("./JSONSchemaInput");
var JSONSchemaStore_1 = require("./JSONSchemaStore");
var Inference_1 = require("./Inference");
var InferMaps_1 = require("./InferMaps");
var TypeBuilder_1 = require("./TypeBuilder");
var TypeGraph_1 = require("./TypeGraph");
var TypeNames_1 = require("./TypeNames");
var GraphQL_1 = require("./GraphQL");
var GatherNames_1 = require("./GatherNames");
var InferEnums_1 = require("./InferEnums");
var TypeAttributes_1 = require("./TypeAttributes");
var FlattenUnions_1 = require("./FlattenUnions");
var ResolveIntersections_1 = require("./ResolveIntersections");
// Re-export essential types and functions
var TargetLanguage_1 = require("./TargetLanguage");
exports.TargetLanguage = TargetLanguage_1.TargetLanguage;
var All_1 = require("./Language/All");
exports.languages = All_1.all;
exports.languageNamed = All_1.languageNamed;
var stringToStream = require("string-to-stream");
function getTargetLanguage(nameOrInstance) {
    if (typeof nameOrInstance === "object") {
        return nameOrInstance;
    }
    var language = targetLanguages.languageNamed(nameOrInstance);
    if (language !== undefined) {
        return language;
    }
    throw new Error("'" + nameOrInstance + "' is not yet supported as an output language.");
}
exports.getTargetLanguage = getTargetLanguage;
function isJSONSource(source) {
    return "samples" in source;
}
exports.isJSONSource = isJSONSource;
function isSchemaSource(source) {
    return !("query" in source) && !("samples" in source);
}
exports.isSchemaSource = isSchemaSource;
function isGraphQLSource(source) {
    return "query" in source;
}
exports.isGraphQLSource = isGraphQLSource;
var defaultOptions = {
    lang: "ts",
    sources: [],
    handlebarsTemplate: undefined,
    findSimilarClassesSchemaURI: undefined,
    inferMaps: true,
    inferEnums: true,
    inferDates: true,
    alphabetizeProperties: false,
    allPropertiesOptional: false,
    combineClasses: true,
    fixedTopLevels: false,
    noRender: false,
    leadingComments: undefined,
    rendererOptions: {},
    indentation: undefined,
    outputFilename: "stdout",
    schemaStore: undefined,
    debugPrintGraph: false
};
function toReadable(source) {
    return _.isString(source) ? stringToStream(source) : source;
}
function toString(source) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!_.isString(source)) return [3 /*break*/, 1];
                    _a = source;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, get_stream_1.getStream(source)];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3: return [2 /*return*/, _a];
            }
        });
    });
}
var InputJSONSchemaStore = /** @class */ (function (_super) {
    __extends(InputJSONSchemaStore, _super);
    function InputJSONSchemaStore(_inputs, _delegate) {
        var _this = _super.call(this) || this;
        _this._inputs = _inputs;
        _this._delegate = _delegate;
        return _this;
    }
    InputJSONSchemaStore.prototype.fetch = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var maybeInput, _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        maybeInput = this._inputs.get(address);
                        if (!(maybeInput !== undefined)) return [3 /*break*/, 2];
                        _a = JSONSchemaInput_1.checkJSONSchema;
                        _c = (_b = JSON).parse;
                        return [4 /*yield*/, toString(maybeInput)];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_c.apply(_b, [_d.sent()])])];
                    case 2:
                        if (this._delegate === undefined) {
                            return [2 /*return*/, Support_1.panic("Schema URI " + address + " requested, but no store given")];
                        }
                        return [4 /*yield*/, this._delegate.fetch(address)];
                    case 3: return [2 /*return*/, _d.sent()];
                }
            });
        });
    };
    return InputJSONSchemaStore;
}(JSONSchemaStore_1.JSONSchemaStore));
var Run = /** @class */ (function () {
    function Run(options) {
        var _this = this;
        this.run = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var targetLanguage, schemaInputs, schemaSources, _i, _a, source, uri, schema, normalizedURI, _b, _c, source, name, schema, query, _d, _e, _f, name, samples, description, _g, samples_1, sample, input, graph, cliques, lines, _h, cliques_1, clique;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        targetLanguage = getTargetLanguage(this._options.lang);
                        schemaInputs = immutable_1.Map();
                        schemaSources = immutable_1.List();
                        for (_i = 0, _a = this._options.sources; _i < _a.length; _i++) {
                            source = _a[_i];
                            if (!isSchemaSource(source))
                                continue;
                            uri = source.uri, schema = source.schema;
                            normalizedURI = void 0;
                            if (uri === undefined) {
                                normalizedURI = new URI("-" + (schemaInputs.size + 1));
                            }
                            else {
                                normalizedURI = new URI(uri).normalize();
                            }
                            if (schema === undefined) {
                                Support_1.assert(uri !== undefined, "URI must be given if schema source is not specified");
                            }
                            else {
                                schemaInputs = schemaInputs.set(normalizedURI.clone().hash("").toString(), schema);
                            }
                            schemaSources = schemaSources.push([normalizedURI, source]);
                        }
                        if (!!schemaSources.isEmpty()) return [3 /*break*/, 2];
                        if (schemaInputs.isEmpty()) {
                            if (this._options.schemaStore === undefined) {
                                return [2 /*return*/, Support_1.panic("Must have a schema store to process JSON Schema")];
                            }
                            this._schemaStore = this._options.schemaStore;
                        }
                        else {
                            this._schemaStore = new InputJSONSchemaStore(schemaInputs, this._options.schemaStore);
                        }
                        return [4 /*yield*/, Support_1.forEachSync(schemaSources, function (_a) {
                                var normalizedURI = _a[0], source = _a[1];
                                return __awaiter(_this, void 0, void 0, function () {
                                    var _this = this;
                                    var name, topLevelRefs, definitionRefs;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                name = source.name, topLevelRefs = source.topLevelRefs;
                                                if (!(topLevelRefs !== undefined)) return [3 /*break*/, 2];
                                                Support_1.assert(topLevelRefs.length === 1 && topLevelRefs[0] === "/definitions/", "Schema top level refs must be `/definitions/`");
                                                return [4 /*yield*/, JSONSchemaInput_1.definitionRefsInSchema(this.getSchemaStore(), normalizedURI.toString())];
                                            case 1:
                                                definitionRefs = _b.sent();
                                                definitionRefs.forEach(function (ref, name) {
                                                    _this.addSchemaInput(name, ref);
                                                });
                                                return [3 /*break*/, 3];
                                            case 2:
                                                this.addSchemaInput(name, JSONSchemaInput_1.Ref.parse(normalizedURI.toString()));
                                                _b.label = 3;
                                            case 3: return [2 /*return*/];
                                        }
                                    });
                                });
                            })];
                    case 1:
                        _j.sent();
                        _j.label = 2;
                    case 2:
                        _b = 0, _c = this._options.sources;
                        _j.label = 3;
                    case 3:
                        if (!(_b < _c.length)) return [3 /*break*/, 12];
                        source = _c[_b];
                        if (!isGraphQLSource(source)) return [3 /*break*/, 5];
                        name = source.name, schema = source.schema, query = source.query;
                        _d = this._allInputs.graphQLs;
                        _e = name;
                        _f = { schema: schema };
                        return [4 /*yield*/, toString(query)];
                    case 4:
                        _d[_e] = (_f.query = _j.sent(), _f);
                        return [3 /*break*/, 11];
                    case 5:
                        if (!isJSONSource(source)) return [3 /*break*/, 10];
                        name = source.name, samples = source.samples, description = source.description;
                        _g = 0, samples_1 = samples;
                        _j.label = 6;
                    case 6:
                        if (!(_g < samples_1.length)) return [3 /*break*/, 9];
                        sample = samples_1[_g];
                        return [4 /*yield*/, this._compressedJSON.readFromStream(toReadable(sample))];
                    case 7:
                        input = _j.sent();
                        if (!_.has(this._allInputs.samples, name)) {
                            this._allInputs.samples[name] = { samples: [] };
                        }
                        this._allInputs.samples[name].samples.push(input);
                        if (description !== undefined) {
                            this._allInputs.samples[name].description = description;
                        }
                        _j.label = 8;
                    case 8:
                        _g++;
                        return [3 /*break*/, 6];
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        if (!isSchemaSource(source)) {
                            Support_1.assertNever(source);
                        }
                        _j.label = 11;
                    case 11:
                        _b++;
                        return [3 /*break*/, 3];
                    case 12: return [4 /*yield*/, this.makeGraph()];
                    case 13:
                        graph = _j.sent();
                        if (this._options.noRender) {
                            return [2 /*return*/, this.makeSimpleTextResult(["Done.", ""])];
                        }
                        if (this._options.findSimilarClassesSchemaURI !== undefined) {
                            cliques = CombineClasses_1.findSimilarityCliques(graph, true);
                            lines = [];
                            if (cliques.length === 0) {
                                lines.push("No similar classes found.");
                            }
                            else {
                                for (_h = 0, cliques_1 = cliques; _h < cliques_1.length; _h++) {
                                    clique = cliques_1[_h];
                                    lines.push("similar: " + clique.map(function (c) { return c.getCombinedName(); }).join(", "));
                                }
                            }
                            lines.push("");
                            return [2 /*return*/, this.makeSimpleTextResult(lines)];
                        }
                        if (this._options.handlebarsTemplate !== undefined) {
                            return [2 /*return*/, immutable_1.OrderedMap([
                                    [
                                        this._options.outputFilename,
                                        targetLanguage.processHandlebarsTemplate(graph, this._options.rendererOptions, this._options.handlebarsTemplate)
                                    ]
                                ])];
                        }
                        else {
                            return [2 /*return*/, targetLanguage.renderGraphAndSerialize(graph, this._options.outputFilename, this._options.alphabetizeProperties, this._options.leadingComments, this._options.rendererOptions, this._options.indentation)];
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this._options = _.mergeWith(_.clone(options), defaultOptions, function (o, s) { return (o === undefined ? s : o); });
        this._allInputs = { samples: {}, schemas: {}, graphQLs: {} };
        var mapping = getTargetLanguage(this._options.lang).stringTypeMapping;
        var makeDate = mapping.date !== "string";
        var makeTime = mapping.time !== "string";
        var makeDateTime = mapping.dateTime !== "string";
        this._compressedJSON = new CompressedJSON_1.CompressedJSON(makeDate, makeTime, makeDateTime);
    }
    Run.prototype.getSchemaStore = function () {
        return Support_1.defined(this._schemaStore);
    };
    Run.prototype.makeGraph = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var targetLanguage, stringTypeMapping, conflateNumbers, haveSchemas, typeBuilder, schemaInputs, numInputs, doInferEnums, numSamples, inference_1, graph, intersectionsDone, unionsDone, graphBeforeRewrites, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        targetLanguage = getTargetLanguage(this._options.lang);
                        stringTypeMapping = targetLanguage.stringTypeMapping;
                        conflateNumbers = !targetLanguage.supportsUnionsWithBothNumberTypes;
                        haveSchemas = Object.getOwnPropertyNames(this._allInputs.schemas).length > 0;
                        typeBuilder = new TypeBuilder_1.TypeGraphBuilder(stringTypeMapping, this._options.alphabetizeProperties, this._options.allPropertiesOptional, haveSchemas, false);
                        schemaInputs = immutable_1.Map(this._allInputs.schemas).map(function (_a) {
                            var ref = _a.ref;
                            return ref;
                        });
                        if (this._options.findSimilarClassesSchemaURI !== undefined) {
                            schemaInputs = schemaInputs.set("ComparisonBaseRoot", JSONSchemaInput_1.Ref.parse(this._options.findSimilarClassesSchemaURI));
                        }
                        if (!!schemaInputs.isEmpty()) return [3 /*break*/, 2];
                        return [4 /*yield*/, JSONSchemaInput_1.addTypesInSchema(typeBuilder, this.getSchemaStore(), schemaInputs)];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2:
                        numInputs = Object.keys(this._allInputs.graphQLs).length;
                        immutable_1.Map(this._allInputs.graphQLs).forEach(function (_a, name) {
                            var schema = _a.schema, query = _a.query;
                            var newTopLevels = GraphQL_1.makeGraphQLQueryTypes(name, typeBuilder, schema, query);
                            newTopLevels.forEach(function (t, actualName) {
                                typeBuilder.addTopLevel(numInputs === 1 ? name : actualName, t);
                            });
                        });
                        doInferEnums = this._options.inferEnums;
                        numSamples = Object.keys(this._allInputs.samples).length;
                        if (numSamples > 0) {
                            inference_1 = new Inference_1.TypeInference(typeBuilder, doInferEnums, this._options.inferDates);
                            immutable_1.Map(this._allInputs.samples).forEach(function (_a, name) {
                                var samples = _a.samples, description = _a.description;
                                var tref = inference_1.inferType(_this._compressedJSON, TypeNames_1.makeNamesTypeAttributes(name, false), samples, _this._options.fixedTopLevels);
                                typeBuilder.addTopLevel(name, tref);
                                if (description !== undefined) {
                                    var attributes = TypeAttributes_1.descriptionTypeAttributeKind.makeAttributes(immutable_1.OrderedSet([description]));
                                    typeBuilder.addAttributes(tref, attributes);
                                }
                            });
                        }
                        graph = typeBuilder.finish();
                        if (this._options.debugPrintGraph) {
                            graph.setPrintOnRewrite();
                            graph.printGraph();
                        }
                        if (haveSchemas) {
                            intersectionsDone = false;
                            unionsDone = false;
                            do {
                                graphBeforeRewrites = graph;
                                if (!intersectionsDone) {
                                    _a = ResolveIntersections_1.resolveIntersections(graph, stringTypeMapping), graph = _a[0], intersectionsDone = _a[1];
                                }
                                if (!unionsDone) {
                                    _b = FlattenUnions_1.flattenUnions(graph, stringTypeMapping, conflateNumbers), graph = _b[0], unionsDone = _b[1];
                                }
                                if (graph === graphBeforeRewrites) {
                                    Support_1.assert(intersectionsDone && unionsDone, "Graph didn't change but we're not done");
                                }
                            } while (!intersectionsDone || !unionsDone);
                        }
                        if (this._options.findSimilarClassesSchemaURI !== undefined) {
                            return [2 /*return*/, graph];
                        }
                        if (this._options.combineClasses) {
                            graph = CombineClasses_1.combineClasses(graph, stringTypeMapping, this._options.alphabetizeProperties, conflateNumbers);
                        }
                        if (doInferEnums) {
                            graph = InferEnums_1.inferEnums(graph, stringTypeMapping);
                        }
                        graph = InferEnums_1.flattenStrings(graph, stringTypeMapping);
                        if (this._options.inferMaps) {
                            graph = InferMaps_1.inferMaps(graph, stringTypeMapping, conflateNumbers);
                        }
                        graph = TypeGraph_1.noneToAny(graph, stringTypeMapping);
                        if (!targetLanguage.supportsOptionalClassProperties) {
                            graph = TypeGraph_1.optionalToNullable(graph, stringTypeMapping);
                        }
                        // Sometimes we combine classes in ways that will the order come out
                        // differently compared to what it would be from the equivalent schema,
                        // so we always just garbage collect to get a defined order and be done
                        // with it.
                        // FIXME: We don't actually have to do this if any of the above graph
                        // rewrites did anything.  We could just check whether the current graph
                        // is different from the one we started out with.
                        graph = graph.garbageCollect(this._options.alphabetizeProperties);
                        GatherNames_1.gatherNames(graph);
                        if (this._options.debugPrintGraph) {
                            console.log("\n# gather names");
                            graph.printGraph();
                        }
                        return [2 /*return*/, graph];
                }
            });
        });
    };
    Run.prototype.makeSimpleTextResult = function (lines) {
        return immutable_1.OrderedMap([[this._options.outputFilename, { lines: lines, annotations: immutable_1.List() }]]);
    };
    Run.prototype.addSchemaInput = function (name, ref) {
        if (_.has(this._allInputs.schemas, name)) {
            throw new Error("More than one schema given for " + name);
        }
        this._allInputs.schemas[name] = { ref: ref };
    };
    return Run;
}());
exports.Run = Run;
function quicktypeMultiFile(options) {
    return new Run(options).run();
}
exports.quicktypeMultiFile = quicktypeMultiFile;
function offsetLocation(loc, lineOffset) {
    return { line: loc.line + lineOffset, column: loc.column };
}
function offsetSpan(span, lineOffset) {
    return { start: offsetLocation(span.start, lineOffset), end: offsetLocation(span.end, lineOffset) };
}
function quicktype(options) {
    return __awaiter(this, void 0, void 0, function () {
        var result, first, lines, annotations;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, quicktypeMultiFile(options)];
                case 1:
                    result = _a.sent();
                    if (result.size <= 1) {
                        first = result.first();
                        if (first === undefined) {
                            return [2 /*return*/, { lines: [], annotations: immutable_1.List() }];
                        }
                        return [2 /*return*/, first];
                    }
                    lines = [];
                    annotations = [];
                    result.forEach(function (srr, filename) {
                        var offset = lines.length + 2;
                        lines = lines.concat(["// " + filename, ""], srr.lines);
                        annotations = annotations.concat(srr.annotations.map(function (ann) { return ({ annotation: ann.annotation, span: offsetSpan(ann.span, offset) }); }).toArray());
                    });
                    return [2 /*return*/, { lines: lines, annotations: immutable_1.List(annotations) }];
            }
        });
    });
}
exports.quicktype = quicktype;
